/*
Copyright (C) 2009  Ruan Strydom <ruan@jcell.co.za>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef PROPERTYNODE_H
#define PROPERTYNODE_H

#include <QtGui/QIcon>
#include <language/duchain/declaration.h>


using namespace KDevelop;

class PropertyNode
{
public:
    PropertyNode ();
    virtual ~PropertyNode();


    virtual const QString& readerName() const { return m_readerName; }

    virtual void setReaderName ( const QString& rn ) { m_readerName = rn; }

    virtual bool createReader() const { return m_createReader; }

    virtual void setCreateReader ( bool cr ) { m_createReader = cr; }

    virtual bool canCreateReader() const { return m_canCreateReader; }

    virtual void setCanCreateReader ( bool ccr ) { m_canCreateReader = ccr; }

    virtual const QString& readerAccess() const { return m_readerAccess; }

    virtual void setReaderAccess ( const QString& ra ) { m_readerAccess = ra; }

    virtual const QString& writerName() const { return m_writerName; }

    virtual void setWriterName ( const QString& wn ) { m_writerName = wn; }

    virtual bool createWriter() const { return m_createWriter; }

    virtual void setCreateWriter ( bool cw ) { m_createWriter = cw; }

    virtual bool canCreateWriter() const { return m_canCreateWriter; }

    virtual void setCanCreateWriter ( bool ccw ) { m_canCreateWriter = ccw; }

    virtual const QString& writerAccess() const { return m_writerAccess; }

    virtual void setWriterAccess ( const QString& wa ) { m_writerAccess = wa; }

    virtual const QString& name() const { return m_name; }

    virtual void setName ( const QString& n ) { m_name = n; }

    virtual const QIcon& icon() const { return m_icon; }

    virtual void setIcon ( const QIcon& i ) { m_icon = i; }

    virtual const QString& type() const { return m_type; }

    virtual void setType ( const QString& t ) { m_type = t; }

    virtual const QString& resolvedType() const { return m_resolvedType; }

    virtual void setResolvedType ( const QString& rt ) { m_resolvedType = rt; }

    virtual KDevelop::AbstractType::WhichType whichType() const { return m_whichType; }

    virtual void setWhichType ( KDevelop::AbstractType::WhichType wt ) { m_whichType = wt; }
    
protected:
    QString m_readerName;
    bool m_createReader;
    bool m_canCreateReader;
    QString m_readerAccess;

    QString m_writerName;
    bool m_createWriter;
    bool m_canCreateWriter;
    QString m_writerAccess;

    QString m_name;
    QIcon m_icon;

    QString m_type;
    QString m_resolvedType;
    AbstractType::WhichType m_whichType;
};

#endif // PROPERTYNODE_H

// kate: indent-mode cstyle; space-indent on; indent-width 4; replace-tabs on;
