/*
Copyright (C) 2009  Ruan Strydom <ruan@jcell.co.za>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KDEVPLUGPLUGIN_H_
#define KDEVPLUGPLUGIN_H_

#include <interfaces/iplugin.h>

#include <QVariantList>

class KAction;

using namespace KDevelop;

namespace KDevelop
{
class Declaration;
class DUContext;
class ClassDeclaration ;
class ClassMemberDeclaration ;
}

//kind = Type
class ReaderWriterPlugin: public KDevelop::IPlugin
{
    Q_OBJECT
public:
    ReaderWriterPlugin (QObject *parent, const QVariantList & = QVariantList());
    ~ReaderWriterPlugin();
    KDevelop::ContextMenuExtension contextMenuExtension (Context* context);
    void createProperties (QList<Declaration*> decls);
private slots:
    void slotCreateProperties();
    void slotWriteProperties();

private:
    static QList<Declaration*> cursorItemDeclarations();
    //kind = Instance
    KAction *m_action;
};

#endif //KDEVPLUG

// kate: indent-mode cstyle; space-indent on; indent-width 4; replace-tabs on;
